net.sf.saxon.functions

## Interface FunctionLibrary

- All Superinterfaces:
    Serializable
  All Known Subinterfaces:
    XQueryFunctionBinder
  All Known Implementing Classes:
    AccumulatorManagerEE, AccumulatorManagerPE, ConstructorFunctionLibrary, ExecutableFunctionLibrary, ExtraFunctionLibrary, FunctionLibraryList, ImportedFunctionLibrary, IntegratedFunctionLibrary, JavaExtensionLibrary, StylesheetFunctionLibrary, SystemFunctionLibrary, UnboundFunctionLibrary, VendorFunctionLibrary, XPathFunctionLibrary, XQueryFunctionLibrary

      public interface FunctionLibrary
      extends Serializable

  A FunctionLibrary handles the binding of function calls in XPath (or XQuery) expressions. There are a number of implementations of this class to handle different kinds of function: system functions, constructor functions, vendor-defined functions, Java extension functions, stylesheet functions, and so on. There is also an implementation `FunctionLibraryList` that allows a FunctionLibrary to be constructed by combining other FunctionLibrary objects.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Expression` | `bind(StructuredQName functionName, int arity, Expression[] staticArgs, StaticContext env, Container container)` Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `FunctionItem` | `getFunctionItem(StructuredQName functionName, int arity, StaticContext staticContext)` Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `boolean` | `isAvailable(StructuredQName functionName, int arity)` Test whether a function with a given name and arity is available

- - ### Method Detail

    - #### isAvailable

          boolean isAvailable(StructuredQName functionName,
                            int arity)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Parameters:
        `functionName` - the qualified name of the function being called
        `arity` - The number of arguments.
      Returns:
        true if a function of this name and arity is available for calling

    - #### bind

          Expression bind(StructuredQName functionName,
                        int arity,
                        Expression[] staticArgs,
                        StaticContext env,
                        Container container)
                          throws XPathException

      Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Parameters:
        `functionName` - the QName of the function being called
        `arity` - The number of arguments supplied in the function call
        `staticArgs` - May be null; if present, the length of the array must match the value of arity. Contains the expressions supplied statically in arguments to the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

        The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).

        `env` - The static context of the function call
        `container` - The container for the newly created Expression
      Returns:
        An expression equivalent to a call on the specified function, if one is found; null if no function was found matching the required name and arity.
      Throws:
        `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

    - #### copy

          FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Returns:
        a copy of this function library. This must be an instance of the original class.

    - #### getFunctionItem

          FunctionItem getFunctionItem(StructuredQName functionName,
                                     int arity,
                                     StaticContext staticContext)
                                       throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Parameters:
        `functionName` - the qualified name of the function being called
        `arity` - The number of arguments.
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.